############################## Imports   ######################################
#region
import glfw
import glfw.GLFW as GLFW_CONSTANTS
from OpenGL.GL import *
from OpenGL.GL.shaders import compileProgram,compileShader
import numpy as np
import pyrr
from PIL import Image
from numba import njit
#endregion
############################## Constants ######################################
#region
SCREEN_WIDTH = 640
SCREEN_HEIGHT = 480

OBJECT_TYPE_CUBE = 0
OBJECT_TYPE_LIGHT = 1

PIPELINE_TYPE_STANDARD = 0
PIPELINE_TYPE_LIT = 1
#endregion
############################## Mat4 Access ####################################
#region
MAT4_STRIDE = 16
MAT4_R1C1   =  0
MAT4_R2C1   =  1
MAT4_R3C1   =  2
MAT4_R4C1   =  3
MAT4_R1C2   =  4
MAT4_R2C2   =  5
MAT4_R3C2   =  6
MAT4_R4C2   =  7
MAT4_R1C3   =  8
MAT4_R2C3   =  9
MAT4_R3C3   = 10
MAT4_R4C3   = 11
MAT4_R1C4   = 12
MAT4_R2C4   = 13
MAT4_R3C4   = 14
MAT4_R4C4   = 15
#endregion
############################## Transform Component Access #####################
#region
TRANSFORM_STRIDE    = 8
TRANSFORM_OFFSET_X  = 0
TRANSFORM_OFFSET_Y  = 1
TRANSFORM_OFFSET_Z  = 2
TRANSFORM_OFFSET_EX = 4
TRANSFORM_OFFSET_EY = 5
TRANSFORM_OFFSET_EZ = 6
#endregion
############################## Velocity Component Access  #####################
#region
VELOCITY_STRIDE    = 8
VELOCITY_OFFSET_X  = 0
VELOCITY_OFFSET_Y  = 1
VELOCITY_OFFSET_Z  = 2
VELOCITY_OFFSET_EX = 4
VELOCITY_OFFSET_EY = 5
VELOCITY_OFFSET_EZ = 6
#endregion
############################## Color Component Access     #####################
#region
COLOR_STRIDE   = 4
COLOR_OFFSET_R = 0
COLOR_OFFSET_G = 1
COLOR_OFFSET_B = 2
COLOR_OFFSET_S = 3
#endregion
############################## Light Component Access     #####################
#region
LIGHT_STRIDE   = 8
LIGHT_OFFSET_X = 0
LIGHT_OFFSET_Y = 1
LIGHT_OFFSET_Z = 2
LIGHT_OFFSET_R = 4
LIGHT_OFFSET_G = 5
LIGHT_OFFSET_B = 6
LIGHT_OFFSET_S = 7
#endregion
############################## Player Component Access     ####################
#region
PLAYER_STRIDE    = 15
PLAYER_OFFSET_X  =  0
PLAYER_OFFSET_Y  =  1
PLAYER_OFFSET_Z  =  2
PLAYER_OFFSET_EX =  3
PLAYER_OFFSET_EY =  4
PLAYER_OFFSET_EZ =  5
PLAYER_OFFSET_FX =  6
PLAYER_OFFSET_FY =  7
PLAYER_OFFSET_FZ =  8
PLAYER_OFFSET_RX =  9
PLAYER_OFFSET_RY = 10
PLAYER_OFFSET_RZ = 11
PLAYER_OFFSET_UX = 12
PLAYER_OFFSET_UY = 13
PLAYER_OFFSET_UZ = 14
#endregion
###############################################################################